package de.yourwebs.sudoku;
// import com.apple.eawt.AboutHandler;
// import com.apple.eawt.AppEvent.AboutEvent;
// import com.apple.eawt.AppEvent.QuitEvent;
// import com.apple.eawt.QuitHandler;
// import com.apple.eawt.QuitResponse;

import java.awt.Desktop;

import javax.swing.SwingUtilities;

import de.yourwebs.sudoku.gui.AboutDialog;
import de.yourwebs.sudoku.gui.OptionDialog;
import de.yourwebs.sudoku.gui.SudokuGUI;

// TODO Hints mitspeichern
/*
 * Sudoku.java 22.10.2010 Copyright 2010 - 2023 javabeginners.de. All rights
 * reserved
 * 
 * @author J&ouml;rg Czeschla
 * 
 * This file is a part of Sudoku. Sudoku is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 * 
 * Sudoku is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * Spiele; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
 * Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * An implementation of the well known number puzzle
 * 
 * @author J&ouml;rg Czeschla, <a href="https://javabeginners.de" target=
 *         "_blank">javabeginners.de</a>
 *
 */
public class Sudoku {
    /**
     * Starts the Sudoku game.
     * 
     * @param args
     *            Unused
     */
    public static void main(final String[] args) {
        System.setProperty("apple.laf.useScreenMenuBar", "true");

        System.out
                .println("Starting " + de.yourwebs.sudoku.Config.APP_NAME.value
                        + " " + de.yourwebs.sudoku.Config.APP_VERSION.value
                        + ", build: " + de.yourwebs.sudoku.Config.BUILD.value);
        System.out.println("OS: " + System.getProperty("os.name"));
        System.out.println("OS-VERSION: " + System.getProperty("os.version"));
        System.out
                .println("JAVA-VERSION: " + System.getProperty("java.version"));
        System.out.println("WORKINGDIR.: " + System.getProperty("user.dir"));

        SwingUtilities.invokeLater(() -> {
            SudokuGUI gui = new SudokuGUI();
            if (System.getProperty("os.name").equals("Mac OS X")) {
                // Create custom about und option dialogs
                Desktop desktop = Desktop.getDesktop();
                desktop.setAboutHandler(e -> new AboutDialog());
                desktop.setPreferencesHandler(e -> new OptionDialog(gui));
            }
        });
    }
}
