package de.yourwebs.sudoku.gui;

/*
 * Programmname: Sudoku
 * 
 * @link https://javabeginners.de
 * 
 * @author Joerg Czeschla Copyright 2010 - 2013 - javabeginners.de - Joerg
 * Czeschla mail: gearge@javabeginners.de Stellt den About-Dialog der Anwendung
 * bereit Er besteht aus einer JTabbedPane mit einem About-Panel und einem
 * Panel, das die GPL darstellt
 *
 *
 * This file is a part of Sudoku. Sudoku is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 * 
 * Sudoku is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * TexTEn; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
 * Suite 330, Boston, MA 02111-1307, USA.
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;

import de.yourwebs.sudoku.Config;

/**
 * The About-Dialog of the game which consists of a two tabbed pane. The first
 * one provides a hint to the copyright and additionally gives a short
 * description of how to play the game. In a second tab the license is shown.
 * 
 * @author J&ouml;rg Czeschla, <a href="https://javabeginners.de" target=
 *         "_blank">javabeginners.de</a>
 *
 */
public class AboutDialog extends JDialog implements ActionListener {

    /**
     * Creates a dialog that displays the program information such as version,
     * author and licence.
     */
    public AboutDialog() {
        super();
        this.setTitle("\u00DCber Sudoku");
        this.initComponents();
        this.setTitle(Config.APP_NAME.value + " " + Config.APP_VERSION.value);
        this.setSize(500, 340);
        this.setLocationRelativeTo(null);
        this.setVisible(true);
    }

    /**
     * Initializes the gui's components
     */
    public void initComponents() {

        JButton okButt = new JButton("ok");
        okButt.addActionListener(this);
        final JPanel buttonPanel = new JPanel();
        buttonPanel.add(okButt);

        // About
        final URL imgUrl = this.getClass().getClassLoader()
                .getResource(Config.ICON_PATH.value);
        final ImageIcon icon = new ImageIcon(imgUrl);
        final JLabel topTextLabel = new JLabel(icon, SwingConstants.LEFT);

        final String hauptText = "<html><p bgcolor='#ffffff'>"
                + "<font size='4' color='#ff0000'>Sudoku</font>"
                + "<font size='4' color='#000000'> "
                + "<br>In jedem Feld muss eine Zahl zwischen 1 und der Anzahl der Felder<br>"
                + "in einer Zeile stehen. Dabei darf in jeder Zeile, Spalte und in jedem<br>"
                + "Teilquadrat jede Ziffer nur einmal vorkommen.</font>"
                + "<br><br><font size='2'>" + Config.COPYRIGHT.value + "<br>"
                + Config.APP_NAME.value + " " + Config.APP_VERSION.value
                + ",  build:" + Config.BUILD.value + "</font></html>";
        final JLabel hauptLabel = new JLabel(hauptText, SwingConstants.CENTER);
        // hauptLabel.setBorder(new EmptyBorder(10, 10, 10, 10));

        JPanel aboutPanel = new JPanel();
        aboutPanel.setBackground(Color.WHITE);
        aboutPanel.add(topTextLabel, BorderLayout.NORTH);
        aboutPanel.add(hauptLabel, BorderLayout.CENTER);

        final URL url = this.getClass().getClassLoader()
                .getResource("lizenz/lizenz.htm");

        // Lizenz
        JEditorPane pane = null;
        try {
            pane = new JEditorPane(url);
        } catch (final IOException e) {
            e.printStackTrace();
        }

        JTabbedPane tabbedPane = new JTabbedPane();
        final JScrollPane sp = new JScrollPane(pane,
                ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
                ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

        tabbedPane.add(aboutPanel, "\u00DCber " + Config.APP_NAME.value);
        tabbedPane.add(sp, "Lizenz");

        this.add(tabbedPane, BorderLayout.CENTER);
        this.add(buttonPanel, BorderLayout.SOUTH);
    }

    @Override
    public void actionPerformed(final ActionEvent e) {
        this.dispose();
    }
}
